General-purpose macro for the situation where there may be high-level args
binding typesk.

This probably isn't going to work ....

(handle-high-vars 
   (\\ (context undo-stack env) --low-body--)
   &key
   context undo-stack env
   high-vars high-init high-trans)

-- low-body computes some object we're interested in.

If there are high-vars, then we wrap around that computation something
that (a) binds high vars to unks, yielding effective env; 
(b) evaluates high-init, which returns new context, new undo-stack,
and a value H, which is saved; (c) applies the low-body function to
the enlarged context, undo-stack, and env; (d) eliminates the
unks; (e) passes H + the result(s) of the low-level
computation to high-trans, whose value(s) are returned.

If there are no high-vars, then the low-body function is applied to
context, undo-stack, and env, and the value(s) are returned.

(defun quantified-formula-check (qgoal target-type undo-stack
				 context mvartypes)
   (multi-let (((quant level qvars body junk)
		(match-cond qgoal
		   (:? (?quant ?(:+ ?lev is-Number) ?qvars ?body ?@junk)
		      (values quant lev qvars body))
		   (:? (?quant ?qvars ?body ?@junk)
		      (values quant 0 qvars body junk))
		   (t
		    (values false nil nil nil nil)))))
      (cond ((not quant)
	     (ill-formed-typed-exp qgoal target-type mvartypes))
	    (t
	     (let ((initial-scope-time scope-time*))
		(!= scope-time* (+ *-* 1))
		(multi-let (((univ requirements)
			     (quantifier-analyze quant context))
			    (keep (syn-context-lookup context
						      'keep-quantifiers))
			    ((low high _)
			     (cond ((= level 0)
				    (args-low-high-split qvars false mvartypes))
				   (t
				    (values !() qvars false)))))
		   (let-fun ()
		      (whats-left)
		    :where
 (:def whats-left ()
    (multi-let (((_ high-qvarbdgs high-var-ill-formed)
		 (qvar-list-parse high type-type* mvartypes)))
       (handle-high-vars
	  (\\ (context undo-stack env)
	     (low-quantified-te context undo-stack env))
	  :context context
	  :undo-stack undo-stack
	  :env mvartypes
	  :high-bdgs high-qvarbdgs
	  :high-init
	     (values (cond ((and (not univ)
				 (not keep))
			    (cons-Syn-context
			       (tuple 'keep-quantifiers true)
			       context))
			   (t context))
		     undo-stack
		     (setup-quantified-te level high-qvarbdgs false high-ill-formed))
	  :high-wrap
	    (\\ (high-te low-te undo-stack)
	       (cond ((not univ)
		      (note-bugs high-te (simple-ill-formed-exp
					      "Can't existentially quantify over types"
					      qgoal))))
	       (quantified-te-finish high-te low-te high-qvarbdgs level undo-stack)))))


			   (let ((high-bdgs
				    (Quantified-typed-exp-bindings hqte)))
			      (let ((low-env (vartypes-declare-placeholder-params
						 high-bdgs mvartypes)))
				 (multi-let (((zqte undo-stack-1)
					      (low-quantified-te

						 undo-stack
						 low-env)))
				    (multi-let (((ltype _ undo-stack-2)
						 (tvar-elim
						    (Typed-exp-type zqte)
						    true
						    (list false ':max-if-constrained)
						    initial-scope-time
						    undo-stack-1 low-env)))
				       (quantified-te-finish
					  hqte zqte
					  (high-bdgs-elim-unks
					     ltype
					     high-bdgs initial-scope-time mvartypes)
					  1 undo-stack-2))))))))))
       (repeat :for ((req :in requirements))
	  (cond ((eq req ':existential-effects)
		 ;; Pseudo-requirement, never satisfied
		 (note-existential-in-effect-bug qte))
		(t
		 (verify-requirement req mvartypes qte))))
       (let ((eff-con (syn-context-lookup context 'action-context)))
	  (cond (eff-con
		 (cond ((eq (cadr eff-con) 'condition)
			(verify-requirement
			   (cond ((eq quant 'forall)
				  ':universal-preconditions)
				 (t
				  ':existential-preconditions))
			   mvartypes qte))
		       ((memq quant '(exists exists!))
			(note-bugs
			    qte
			    (list (simple-ill-formed-exp
				     !"Existentials are not allowed ~
				       in action effects"
				     qgoal))))))))
       (cond ((not (null junk))
	      (note-bugs qte (list (simple-ill-formed-exp
				     "Too much stuff in goal body"
				     qgoal)))))
       (values qte undo-stack-2)))

 (:def low-quantified-te (context undo-stack env)
    (multi-let (((constraining low-qvarbdgs low-ill-formed)
		 (qvar-list-parse qvars ':tvar env)))
       (let ((zqte (setup-quantified-te
		      0 low-qvarbdgs constraining low-ill-formed env)))
       (multi-let (((bte undo-stack-1)
		    (term-check
			  body
			  prop-type*
			  undo-stack
			  (context-expstack-push
			     body 2 context)
			  env)))
	  (multi-let (((bindings)
		       (bdgs-tvar-elim
			  (Quantified-typed-exp-bindings zqte)
			  initial-scope-time
			  undo-stack-1)))
	     (quantified-te-finish
		 zqte bte bindings 0 undo-stack-1)))))

 (:def setup-quantified-te (level bindings constraining var-ill-formed env)
       (let ((te (make-inst Quantified-typed-exp
		    :quantifier quant
		    :level level
		    :keep-quantifier (or (not univ) keep)
		    :use-bindings-as-constraints constraining
		    :universal univ
		    :bindings bindings
		    :body '()
		    :source qgoal
		    :env env)))
	  (repeat :for ((vt :in new-qvarbdgs))
	     (!= (vartype-feat vt ':binder) te))
	  (note-bugs te var-ill-formed)
	  te))

 (:def quantified-te-finish (qte body-te bindings level undo-stack)
       (set-fields Quantified-typed-exp qte
	  :body body-te
	  :ext `(,(Quantified-typed-exp-quantifier qte)
		 ,@(include-if (> level 0 level))
		 ,(vartypes-typed-arglist bindings)
		 ,(Typed-exp-ext body-te))
	  :totbugs (+ *-* (Typed-exp-totbugs body-te))
	  :tvars (Typed-exp-tvars body-te)
	  :type (Typed-exp-type body-te)
	  :subexps (list body-te)
	  :bindings bindings)
       (values qte undo-stack)))))))))